<?php


class ControllerExtensionPaymentSadadqa extends Controller
{
    /**
     * Event constants
     */
    const PAYMENT_AUTHORIZED    = 'payment.authorized';
    const PAYMENT_FAILED        = 'payment.failed';
    const ORDER_PAID            = 'order.paid';


    public function index()
    {   
        $this->load->model('checkout/order');

        $order_info = $this->model_checkout_order->getOrder($this->session->data['order_id']);

        $data['return_url'] = $this->url->link('extension/payment/sadadqa/callback', '', 'true');
        $data['oc_version'] = VERSION;

        if (file_exists(DIR_TEMPLATE.$this->config->get('config_template').'/template/extension/payment/sadadqa')) 
        {
            return $this->load->view($this->config->get('config_template').'/template/extension/payment/sadadqa', $data);
        } 
        else 
        {
            return $this->load->view('extension/payment/sadadqa', $data);
        }
    }

    private function get_order_creation_data($order_id)
    {
        $order = $this->model_checkout_order->getOrder($this->session->data['order_id']);

        $data = [
            'receipt' => $order_id,
            'amount' => $this->currency->format($order['total'], $order['currency_code'], $order['currency_value'], false),
            'currency' => $order['currency_code'],
            'payment_capture' =>  0
        ];

        return $data;
    }


    public function callback()
    {
        $this->load->model('checkout/order');
        $orderId=$this->session->data['order_id'];
        $order_info = $this->model_checkout_order->getOrder($orderId);
		
		if( $order_info['currency_code'] != 'QAR')
		{
			 $this->session->data['error'] = 'This payment method supports only QAR currency.';
             $this->response->redirect($this->url->link('checkout/checkout', '', true));
			 exit;
		}
		
		$oItems = $this->model_checkout_order->getOrderProducts($orderId);

        $keyId = $this->config->get('payment_sadadqa_key_id');
        $keySecret = $this->config->get('payment_sadadqa_key_secret');
		$mlng = $this->config->get('payment_sadadqa_language');
		$website = $this->config->get('payment_sadadqa_website');
        $redirect_url = $this->url->link('extension/payment/sadadqa/webhook');
		$chkType = $this->config->get('payment_sadadqa_entry_checkouttype');
		$chkLoader = $this->config->get('payment_sadadqa_hide_loader');
		$chkType2 = $this->config->get('payment_sadadqa_checkouttype2');
		$sCost = filter_var($this->session->data['shipping_method']['text'], FILTER_SANITIZE_NUMBER_FLOAT,FILTER_FLAG_ALLOW_FRACTION);
		
		if(empty($keyId) or empty($keySecret))
		{
			$this->session->data['error'] = 'Payment method not configured.';
            $this->response->redirect($this->url->link('checkout/checkout', '', true));
		}

        $amount = $this->currency->format($order_info['total'], $order_info['currency_code'], $order_info['currency_value'], false);
        $email = $order_info['email'];
        $mobile_no = $order_info['telephone'];
        

		
		try {
            
            
			$txnDate = date('Y-m-d H:i:s');
			$sadad_checksum_array = array();
			$sadad__checksum_data = array();
            $i = 0;
            foreach ($oItems as $item) {
                $qty = $item['quantity'];
                $iPric = $item['price'] + $item['tax'];
                $iTot = round($iPric * $qty, 2);
                $inm = html_entity_decode($item['name']);
				
				$sadad_checksum_array['productdetail'][$i]['order_id']    = $orderId;
				$sadad_checksum_array['productdetail'][$i]['itemname']    = $inm;
				$sadad_checksum_array['productdetail'][$i]['amount']      = $iPric;
				$sadad_checksum_array['productdetail'][$i]['totalamount'] = $iTot;
				$sadad_checksum_array['productdetail'][$i]['quantity']    = $qty;
				$sadad_checksum_array['productdetail'][$i]['type']        = 'line_item';
				$sadad_checksum_array['productdetail'][$i]['item_meta']   = '';
                $i++;
            }
			
			$sadad_checksum_array['merchant_id']                     = $keyId;
            $sadad_checksum_array['ORDER_ID']                        = $orderId;
            $sadad_checksum_array['WEBSITE']                         = $website;
            $sadad_checksum_array['TXN_AMOUNT']                      = number_format((float)$amount, 2, '.', '');
            //$sadad_checksum_array['shipping_rate']                   = number_format((float)$sCost, 2, '.', '');
			$sadad_checksum_array['VERSION']                         = '1.1';
            $sadad_checksum_array['CUST_ID']                         = $email;
            $sadad_checksum_array['EMAIL']                           = $email;
            $sadad_checksum_array['MOBILE_NO']                       = $mobile_no;
            $sadad_checksum_array['MODE']                            = 'yes';
            $sadad_checksum_array['SADAD_WEBCHECKOUT_PAGE_LANGUAGE'] = $mlng;
            $sadad_checksum_array['CALLBACK_URL']                    = $redirect_url;
            $sadad_checksum_array['txnDate']                         = $txnDate;
			
            
            //if webcheckout 2.2, add these fields to checksum
            if ($chkType == 2) {
                $sadad_checksum_array['SADAD_WEBCHECKOUT_HIDE_LOADER'] = $chkLoader;
                $sadad_checksum_array['showdialog']                    = (string) $chkType2;
            }
			$sAry1 = array();
			$sadad_checksum_array1 = array();
			foreach($sadad_checksum_array as $pK => $pV){
				if($pK=='checksumhash') continue;
				if(is_array($pV)){
					$prodSize = sizeof($pV);
					for($i=0;$i<$prodSize;$i++){
						foreach($pV[$i] as $innK => $innV){
							$sAry1[] = "<input type='hidden' name='productdetail[$i][". $innK ."]' value='" . trim($innV) . "'/>";
							$sadad_checksum_array1['productdetail'][$i][$innK]    = trim($innV);
						}
					}
				} else {
					$sAry1[] = "<input type='hidden' name='". $pK ."' id='". $pK ."' value='" . trim($pV) . "'/>";
					$sadad_checksum_array1[$pK]    = trim($pV);
				}
			}
            
            $sadad__checksum_data['postData']  = $sadad_checksum_array1;
            $sadad__checksum_data['secretKey'] = $keySecret;
            $checksum                          = $this->getChecksumFromString(json_encode($sadad__checksum_data), $keySecret . $keyId);
            $sAry1[]                = "<input type='hidden' name='checksumhash' value='" . $checksum . "'/>";
			
			ob_start();
           if ($chkType == 1) {
                $action_url = 'https://sadadqa.com/webpurchase';
                
                echo '<form action="' . $action_url . '" method="post" id="sadad_payment_form" name="gosadad">
                    ' . implode('', $sAry1) . '
                    <script type="text/javascript">
                        document.gosadad.submit();
                    </script>
                    
                </form>';
			   exit;
            } else {
				$action_url = 'https://secure.sadadqa.com/webpurchasepage';
                
                echo '<form action="' . $action_url . '" method="post" id="paymentform" name="paymentform" data-link="' . $action_url . '">
                    ' . implode('', $sAry1) . '
                </form>';
                
?>
               <!--<script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script>
                <script src="https://cdnjs.cloudflare.com/ajax/libs/popper.js/1.12.9/umd/popper.min.js" integrity="sha384-ApNbgh9B+Y1QKtv3Rn7W3mgPxhU9K/ScQsAP7hUibX39j7fakFPskvXusvfa0b4Q" crossorigin="anonymous"></script>
                
                <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.0.0/js/bootstrap.min.js" integrity="sha384-JZR6Spejh4U02d8jOt6vLEHfe/JQGiRRSQQxSfFWpi1MquVdAyjUar5+76PVCmYl" crossorigin="anonymous"></script>
                
                <script src="https://cdnjs.cloudflare.com/ajax/libs/bootstrap-modal/2.2.6/js/bootstrap-modal.min.js"></script>
                
                <script src="https://cdnjs.cloudflare.com/ajax/libs/bootstrap-modal/2.2.6/js/bootstrap-modalmanager.js"></script>
                
                <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/bootstrap-modal/2.2.6/css/bootstrap-modal.min.css" crossorigin="anonymous">
                
                <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/bootstrap-modal/2.2.6/css/bootstrap-modal-bs3patch.min.css" crossorigin="anonymous">-->
                
                    <style>
                        .close-btn{
                            height: auto;
                            width: auto;
                            -webkit-appearance: none !important;
                            background: none !important;
                            border: 0px;
                            position: absolute;
                            right: 10px;
                            z-index: 11;
                            cursor: pointer;
                            outline: 0px !important;
                            box-shadow: none;
                            top: 15px;
                        }
                        .close, .close:hover{
                            color: #000;
                            font-size:30px;
                        }
                        .modal-body{
                            padding: 0px;
                            border-radius: 15px;
                        }
                        #onlyiframe{
                         width:100% !important;
                         height:100vh !important;
                         overflow: hidden !important;
                         border:0;
                        
                         top: 0;
                         left: 0;
                         bottom: 0;
                         right: 0;
                              
                        }
                        #includeiframe{
                            height:100vh !important;
                         overflow: hidden !important;
                        border:0;
						width:100%;
                        }
                        .modal-backdrop {
                           background-color: #000 !important;
                        }
						#exampleModal .modal-content{
							background: #fff !important;
						}
                    </style>
                    <!-- Modal -->
                    <div id="container_div_sadad">
                    <div class="modal fade not_hide_sadad" id="exampleModal" tabindex="-1" role="dialog" aria-labelledby="exampleModalLabel" aria-hidden="true" data-backdrop='static'>
                        <div class="modal-dialog" role="document">
                            <div class="modal-content">
                                <button type="button" class="close-btn" data-dismiss="modal" aria-label="Close">
                                    <span class="close">&times;</span>
                                </button>
                                <div class="modal-body">
                                    <iframe name="includeiframe" id="includeiframe" frameborder="0" scrolling="no"></iframe>
                                </div>
                            </div>
                        </div>
                    </div>
                    <iframe name="onlyiframe" id="onlyiframe" border="0" class="not_hide_sadad" frameborder="0" scrolling="no"></iframe>
                    </div>
                    
                    <script>
                        function closemodal()
                        {
							window.location.href = '<?php echo $this->url->link('checkout/checkout', '', true); ?>';
                            $('#exampleModal').modal('hide');
                        }
                        jQuery(document).ready(function($){
                        
                                if ($('#showdialog').val() == 1) {
                                
                                      $('#exampleModal').modal('show');
                                      $('#paymentform').attr('target', 'includeiframe').submit();
                                      $('#onlyiframe').hide();
                                    
                                } else {
                                     $('#exampleModal').modal('hide');
                                     $('#paymentform').attr('target', 'onlyiframe').submit();
                                    
                                }
                             $('iframe').load(function() {
                                    $(this).height( $(this).contents().find("body").height() );
                                    if(this.contentWindow.location=='<?php
                echo $redirect_url;
?>'){
									
									$(this).hide();
									window.location.href = '<?php echo $this->url->link('checkout/success', '', true); ?>';
                                        
                                    }
                                });    
                        });
                    </script>

                <?php
			}
			$msgDataa = ob_get_contents();
			ob_end_clean();
			
			
			echo $msgDataa;
            exit;
        } catch (Exception $e) {
			$this->session->data['error'] = 'Some error occured while processing the order.';
            $this->response->redirect($this->url->link('checkout/checkout', '', true));
			exit;
        }
    }


    public function webhook()
    {  
        $post = $_POST;
        if (empty($post)) {
            return '';
        }
        $orderId = $post['ORDERID'];
        $this->load->model('checkout/order');
        $order_info = $this->model_checkout_order->getOrder($orderId);		
        try {
            if ($post['RESPCODE'] == 01 or $post['RESPCODE'] == 1) {
				
				$checksum_response = $post['checksumhash'];
				unset($post['checksumhash']);
				$sadad_id                   = $this->config->get('payment_sadadqa_key_id');
				$sadad_secrete_key          = trim($this->config->get('payment_sadadqa_key_secret'));
				$data_repsonse              = array();
				$data_repsonse['postData']  = $post;
				$data_repsonse['secretKey'] = $sadad_secrete_key;
				$key                        = $sadad_secrete_key . $sadad_id;
				if ($this->verifychecksum_eFromStr(json_encode($data_repsonse), $key, $checksum_response) === "TRUE") {

					$ordTotal = $this->currency->format($order_info['total'], $order_info['currency_code'], $order_info['currency_value'], false);
					if ($post['TXNAMOUNT'] >= $ordTotal && $post['STATUS'] == 'TXN_SUCCESS') {
						$payment_id = $post['transaction_number'];
						$this->model_checkout_order->addOrderHistory($orderId, $this->config->get('payment_sadadqa_order_status_id'), 'Payment Successful. Sadad Transaction Id:'.$payment_id, true);              
						$this->response->redirect($this->url->link('checkout/success', '', true));
						//echo $this->url->link('checkout/success', '', true);
						exit;
					} else {
						$this->session->data['error'] = 'Payment failed for order due to mismatch of amounts. Please try again.';
						$this->response->redirect($this->url->link('checkout/cart', '', true));
						
						exit;
					}
				} else {
					 $this->session->data['error'] = 'Payment failed due to checksumhash mismatch.';
                	$this->response->redirect($this->url->link('checkout/cart', '', true));
					
				}
            } else {
			    $this->session->data['error'] = 'Payment failed. Please try again.';
				//print_r($this->session->data['error']);
                $this->response->redirect($this->url->link('checkout/cart', '', true));
            }
        } catch (Exception $e) {
            $error = $e->getMessage();
			$this->session->data['error'] = "Order creation failed. Error: " . $error;
            $this->response->redirect($this->url->link('checkout/cart', '', true));
			//print_r($this->session->data['error']);
            exit;
        }
    }
	
	private function getChecksumFromString($str, $key) {
	
		
	
		$salt = $this->generateSalt_e(4);
	
		$finalString = $str . "|" . $salt;
	
		$hash = hash("sha256", $finalString);
	
		$hashString = $hash . $salt;
	
		$checksum = $this->encrypt_e($hashString, $key);
	
		return $checksum;
	
	}
	
	
	
	private function generateSalt_e($length) {
	
		$random = "";
	
		srand((double) microtime() * 1000000);
	
	
	
		$data = "AbcDE123IJKLMN67QRSTUVWXYZ";
	
		$data .= "aBCdefghijklmn123opq45rs67tuv89wxyz";
	
		$data .= "0FGH45OP89";
	
		for ($i = 0; $i < $length; $i++) {
	
			$random .= substr($data, (rand() % (strlen($data))), 1);
	
		}
	
		return $random;
	
	}



	private function encrypt_e($input, $ky) {
	
	$ky = html_entity_decode($ky);
	
	$iv = "@@@@&&&&####$$$$";
	
	$data = openssl_encrypt($input, "AES-128-CBC", $ky, 0, $iv);
	
	return $data;
	
	}
	
	private function verifychecksum_eFromStr($str, $key, $checksumvalue) {
	
	$sadad_hash = $this->decrypt_e($checksumvalue, $key);
	
	$salt = substr($sadad_hash, -4);
	
	
	
	$finalString = $str . "|" . $salt;
	
	
	
	$website_hash = hash("sha256", $finalString);
	
	$website_hash .= $salt;
	
	
	
	$validFlag = "FALSE";
	
	if ($website_hash == $sadad_hash) {
	
	$validFlag = "TRUE";
	
	} else {
	
	$validFlag = "FALSE";
	
	}
	
	return $validFlag;
	
	}
	
	
	
	private function decrypt_e($crypt, $ky) {
	
	$ky = html_entity_decode($ky);
	
	$iv = "@@@@&&&&####$$$$";
	
	$data = openssl_decrypt($crypt, "AES-128-CBC", $ky, 0, $iv);
	
	return $data;
	
	}
}
